package com.pault;

import org.w3c.dom.Node;
import java.net.*;
import java.io.*;
import org.xml.sax.*;
import com.icl.saxon.trax.*;

import com.icl.saxon.aelfred.SAXDriver;

/**
 * Wrapper around SAXON's SAX2 parser. They declared it final, so
 * I have to use this stupid pattern. Why people are declaring
 * some classes 'final' ? Nobody should do that. Whatever.
 *
 * Creation date: (10/9/00 12:25:22 AM)
 * @author: Paul Tchistopolskii
 */
public class XX implements 	AttributeList, 
							Attributes, 
							Locator, 
							Parser, 
							XMLReader,
							URIResolver {

 	SAXDriver sup = null;		

 	public XX() {
	 		sup = new SAXDriver();
 	}   
public int getColumnNumber() { return sup.getColumnNumber(); }
public org.xml.sax.ContentHandler getContentHandler() {	return sup.getContentHandler(); }
public Node getDOMNode () throws TransformException { return null; }
public DTDHandler getDTDHandler() {	return sup.getDTDHandler(); }
public EntityResolver getEntityResolver() { return sup.getEntityResolver(); }
public ErrorHandler getErrorHandler() {	return sup.getErrorHandler(); }
public boolean getFeature(String arg1) throws org.xml.sax.SAXNotSupportedException, org.xml.sax.SAXNotRecognizedException {
	return sup.getFeature(arg1);
}
public int getIndex(String arg1) {	return sup.getIndex(arg1); }
public int getIndex(String arg1, String arg2) {
	return sup.getIndex(arg1, arg2);
}
 public InputSource getInputSource () throws TransformException { return null;}  
public int getLength() { return sup.getLength(); }
public int getLineNumber() { return sup.getLineNumber(); }
public String getLocalName(int arg1) { return sup.getLocalName(arg1); }
public String getName(int arg1) { return sup.getName(arg1); }
public Object getProperty(String arg1) throws org.xml.sax.SAXNotSupportedException, org.xml.sax.SAXNotRecognizedException {
	return sup.getProperty(arg1);
}
public String getPublicId() { return sup.getPublicId(); }
public String getQName(int arg1) { return sup.getQName(arg1); }
public String getSystemId() { return sup.getSystemId(); }
public String getType(int arg1) { return sup.getType(arg1); }
public String getType(String arg1) { return sup.getType(arg1); }
public String getType(String arg1, String arg2) {
	return sup.getType(arg1,arg2);
}
 	public String getURI () {  return null; } 
public String getURI(int arg1) { return sup.getURI(arg1); }
public String getValue(int arg1) { return sup.getValue(arg1); }
public String getValue(String arg1) { return sup.getValue(arg1); }
public String getValue(String arg1, String arg2) {
	return sup.getValue(arg1, arg2);
}
public XMLReader getXMLReader() throws TransformException 
{
	return new com.pault.XX();	
}
public void parse(String arg1) 
throws java.io.IOException, org.xml.sax.SAXException {
	// System.err.println( "GOT in parse: " + arg1 );
	sup.parse(arg1);
}
public void parse(org.xml.sax.InputSource ins ) 
	throws java.io.IOException, org.xml.sax.SAXException {
		
			String sysid =  ins.getSystemId();			

			// System.err.println( "sysid: " + sysid );	

			if ( sysid.endsWith( ".xsls" ) ) {

				String result = "empty";
				
				try {

					InputStreamReader input = 
							new InputStreamReader( new URL(sysid).openStream() );

					result = 
						com.pault.xslscript.XSLScriptParser.Load( input );

					InputSource newins = 
						new InputSource ( new ByteArrayInputStream( result.getBytes() ) );

					newins.setSystemId( ins.getSystemId() );

					sup.parse( newins );

					newins = null;
						
				} catch ( SAXParseException e ) {
					
					String err = "";

					String systemId =  ( (SAXParseException) e).getSystemId();
					int lineNumber = ( (SAXParseException) e).getLineNumber();
					if (systemId != null)
					  err += systemId + ":";
					if (lineNumber >= 0)
					  err += lineNumber + ":";
	
					if (systemId != null || lineNumber >= 0)
	  				  err += " ";

			  		err += ( (SAXParseException) e).getMessage() + "\n";
			  		err += "XSLScript has generated weird XSL code:"  + "\n";
			  		err += "File: " + systemId + "\n";
			  		// err += result;
		
					throw new org.xml.sax.SAXException( err.toString() );
	
				}
				
				catch ( Exception ee ) {

					throw new org.xml.sax.SAXException( ee.toString() );
				}

				return;
			}
			
			sup.parse( ins );

			
}
public void setContentHandler( org.xml.sax.ContentHandler arg1) {
	sup.setContentHandler(arg1);
}
public void setDocumentHandler(DocumentHandler arg1) {
	 sup.setDocumentHandler(arg1);
}
public void setDTDHandler(DTDHandler arg1) { sup.setDTDHandler(arg1); }
public void setEntityResolver(org.xml.sax.EntityResolver arg1) {
 sup.setEntityResolver(arg1);
}
public void setErrorHandler(org.xml.sax.ErrorHandler arg1)
{
	sup.setErrorHandler(arg1);
}
public void setFeature(String arg1, boolean arg2) 
	throws org.xml.sax.SAXNotSupportedException, org.xml.sax.SAXNotRecognizedException 
{
	sup.setFeature(arg1,arg2);
}
public void setLocale(java.util.Locale arg1) 
	throws org.xml.sax.SAXException {
		sup.setLocale(arg1);
}
public void setProperty(String arg1, Object arg2) 
	throws org.xml.sax.SAXNotSupportedException, 
	org.xml.sax.SAXNotRecognizedException {

			sup.setProperty(arg1,arg2);
		
}
 public void setURI (String base, String uri)
	throws TransformException {}
}
